/*----------------------------------------------------------------------*
    smpl6.c
    Tv6 - Version 1.4
    [High-speed PWM]
    Copyright (C) 2006 BestTechnology CO.,LTD.
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  ^C}/JE^13PWM삳A6chPWMo͂܂B܂R
  yA}b`荞݂gpĔrWX^̒lCNg
  PWM̃f[eB[XV܂B
  ----------------------------------------------------------------------*/

#include <avr/io.h>         // I/O
#include <avr/interrupt.h>  // 荞݊֘A

unsigned short cnt[6] = {0,100,200,300,400,500};

/*-----------------------------------------------*/
/* ^C}/JE^1,3̃RyA}b`A荞   */
/*-----------------------------------------------*/
SIGNAL(SIG_OUTPUT_COMPARE1A)
{
  int i;

  // 1ɔrWX^XV
  for (i = 0; i < 3; i++) if (cnt[i]++ > 500) cnt[i] = 0;
  OCR1A = cnt[0];
  OCR1B = cnt[1];
  OCR1C = cnt[2];
}

SIGNAL(SIG_OUTPUT_COMPARE3A)
{
  int i;

  // 1ɔrWX^XV
  for (i = 3; i < 6; i++) if (cnt[i]++ > 500) cnt[i] = 0;
  OCR3A = cnt[3];
  OCR3B = cnt[4];
  OCR3C = cnt[5];
}

/*-----------------------------------------------*/
/* C                                        */
/*-----------------------------------------------*/
void main(void)
{
  // |[g\
  DDRB = _BV(PINB7) | _BV(PINB6) | _BV(PINB5);  // PB7-5o
  DDRE = _BV(PINE5) | _BV(PINE4) | _BV(PINE3);  // PE5-3o

  // ^C}/JE^荞݃}XNݒ
  TIMSK = _BV(OCIE1A);
  ETIMSK = _BV(OCIE3A);

  // ^C}/JE^1PWM[hɐݒ (ICR1TOP)
  TCNT1   = 0;
  ICR1    = 500;    // TOPl 62.5kHz/500=8ms
  OCR1A   = cnt[0]; // PB5(OC1A)̃f[eB[
  OCR1B   = cnt[1]; // PB6(OC1B)̃f[eB[
  OCR1C   = cnt[2]; // PB7(OC1C)̃f[eB[
  TCCR1A  = _BV(COM1A1) | _BV(COM1B1) | _BV(COM1C1) | _BV(WGM11);
  TCCR1B  = _BV(CS12) | _BV(WGM13) | _BV(WGM12); // /256=62.5kHz

  // ^C}/JE^3PWM[hɐݒ (ICR3TOP)
  TCNT3   = 0;
  ICR3    = 500;    // TOPl 15.625kHz/500=8ms
  OCR3A   = cnt[3]; // PE3(OC3A)̃f[eB[
  OCR3B   = cnt[4]; // PE4(OC3B)̃f[eB[
  OCR3C   = cnt[5]; // PE5(OC3C)̃f[eB[
  TCCR3A  = _BV(COM3A1) | _BV(COM3B1) | _BV(COM3C1) | _BV(WGM31);
  TCCR3B  = _BV(CS32) | _BV(WGM33) | _BV(WGM32); // /256=62.5kHz

  // 荞݋
  sei ();

  while (1) {   // [v
  }
}
